//---------------------------------------------------------------------------

#include <vcl.h>
#include <iterator>
#include "algostuff.hpp"

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

int main()
{
  vector<int> coll1;
  list<int> coll2;

  INSERT_ELEMENTS(coll1,1,6);
  for (int i=1; i<=16; i*=2) {
      coll2.push_back(i);
  }
  coll2.push_back(3);

  PRINT_ELEMENTS(coll1,":\n");
  PRINT_ELEMENTS(coll2,":\n");

  //   
  pair<vector<int>::iterator,list<int>::iterator> values;
  values = mismatch (coll1.begin(), coll1.end(),  //  
                     coll2.begin());              //  
  if (values.first == coll1.end()) {
        cout << ToRus(" .") << endl;
  }
  else {
    cout << ToRus(" : ")
         << *values.first  << ToRus("  ")
         << *values.second << endl;
    }

  //   ,    coll
  //       coll2
  values = mismatch (coll1.begin(), coll1.end(),  //  
                     coll2.begin(),               //  
                     less_equal<int>());          // 
  if (values.first == coll1.end()) {
      cout << ToRus("   .") << endl;
    }
    else {
        cout << ToRus("   \n")
             << ToRus(" : ")
             << *values.first << ToRus("  ")
             << *values.second << endl;
    }


  getch();
  return 0;
}

//---------------------------------------------------------------------------